<template>
    <div id="conteneur-goban">
        <div id="board"></div>
    </div>
</template>

<script lang="ts">
// @ts-ignore
import WGo from 'wgo';
import Component, { mixins } from 'vue-class-component';
import Goban from './Goban.vue';
import Coup from '@/classes/Coup';
import coordonnees from './Coordonnees';

@Component
export default class GobanJeu extends mixins(Goban) {
    game: any;
    tool = WGo.B;

    beforeDestroy() {
        this.board.removeEventListener('click', this.getListener());
    }

    initialiser() {
        this.setBoard();
        if (this.position) {
            this.setGame(this.position.tailleGoban);
        } else {
            this.setGame();
        }
        this.ajouterListener();
        this.board.addCustomObject(coordonnees);
    }

    definirSize() {
        this.size = document.getElementById('probleme-container').clientWidth;
        this.size =
            this.size == 0
                ? Math.round(document.documentElement.clientWidth * 0.179)
                : this.size;
    }

    ajouterListener() {
        this.board.addEventListener('click', this.getListener());
    }

    getListener() {
        /** A redéfinir dans chaque implémentation.*/
    }

    ajouterCoup(coup: Coup) {
        this.ajouterPierre(coup.getX(), coup.getY(), coup.getTool());
    }

    ajouterPierre(x, y, couleur) {
        this.supprimerMarqueursEnCours();
        this.putPierre(x, y, couleur);
    }

    putCoup(coup: Coup) {
        this.putPierre(coup.getX(), coup.getY(), coup.getTool());
    }

    putPierre(x, y, couleur) {
        this.board.addObject({
            x: x,
            y: y,
            c: couleur
        });
        const capture = this.game.play(x, y, couleur);
        this.gererCapturePierre(capture);
    }

    gererCapturePierre(pierresCapturees: any[]) {
        pierresCapturees.forEach(element => {
            this.retirerElement(element.x, element.y);
        });
    }

    isPierreValide(x, y, couleur) {
        return this.game.isValid(x, y, couleur);
    }

    retirerElement(x, y) {
        this.board.removeObjectsAt(x, y);
    }

    public setGame(taille?: number) {
        if (taille) {
            this.game = new WGo.Game(taille, 'KO');
        } else {
            this.game = new WGo.Game(19, 'KO');
        }
    }

    coupStandard(x, y) {
        x = parseInt(x);
        y = parseInt(y);
        if (this.isPierreValide(x, y, this.tool)) {
            this.ajouterPierre(x, y, this.tool);
            this.changerCouleur();
        }
    }

    changerCouleur() {
        this.tool = this.tool === WGo.B ? WGo.W : WGo.B;
    }

    isAfficherCoordonnees(): boolean {
        return true;
    }
}
</script>

<style></style>
